# generated by datamodel-codegen:
#   filename:  datacite_4.3_schema.json
#   timestamp: 2023-01-26T18:29:42+00:00

from __future__ import annotations

from enum import Enum
from typing import Any, List, Optional, Union
from typing_extensions import Annotated

from pydantic import (
    AnyUrl,
    BaseModel,
    Field,
    confloat,
    AfterValidator,
    RootModel,
    ConfigDict,
    field_validator,
)
from garden_ai.utils.pydantic import unique_items_validator, const_item_validator


require_unique_items = AfterValidator(unique_items_validator)


class Identifier(BaseModel):
    identifier: str
    identifierType: str


class Subject(BaseModel):
    subject: str
    subjectScheme: Optional[str] = None
    schemeUri: Optional[AnyUrl] = None
    valueUri: Optional[AnyUrl] = None
    lang: Optional[str] = None


class AlternateIdentifier(BaseModel):
    alternateIdentifier: str
    alternateIdentifierType: str


class RightsListItem(BaseModel):
    rights: Optional[str] = None
    rightsUri: Optional[AnyUrl] = None
    rightsIdentifier: Optional[str] = None
    rightsIdentifierScheme: Optional[str] = None
    schemeUri: Optional[AnyUrl] = None
    lang: Optional[str] = None


class Container(BaseModel):
    type: Optional[str] = None
    title: Optional[str] = None
    firstPage: Optional[str] = None


class NameType(str, Enum):
    Organizational = "Organizational"
    Personal = "Personal"


class NameIdentifier(BaseModel):
    nameIdentifier: str
    nameIdentifierScheme: str
    schemeUri: Optional[AnyUrl] = None


class NameIdentifiers(RootModel):
    root: Annotated[List[NameIdentifier], require_unique_items]


class Affiliation(BaseModel):
    name: str
    affiliationIdentifier: Optional[str] = None
    affiliationIdentifierScheme: Optional[str] = None
    schemeUri: Optional[AnyUrl] = None


class Affiliations(RootModel):
    root: Annotated[List[Affiliation], require_unique_items]


class TitleType(str, Enum):
    AlternativeTitle = "AlternativeTitle"
    Subtitle = "Subtitle"
    TranslatedTitle = "TranslatedTitle"
    Other = "Other"


class ContributorType(str, Enum):
    ContactPerson = "ContactPerson"
    DataCollector = "DataCollector"
    DataCurator = "DataCurator"
    DataManager = "DataManager"
    Distributor = "Distributor"
    Editor = "Editor"
    HostingInstitution = "HostingInstitution"
    Producer = "Producer"
    ProjectLeader = "ProjectLeader"
    ProjectManager = "ProjectManager"
    ProjectMember = "ProjectMember"
    RegistrationAgency = "RegistrationAgency"
    RegistrationAuthority = "RegistrationAuthority"
    RelatedPerson = "RelatedPerson"
    Researcher = "Researcher"
    ResearchGroup = "ResearchGroup"
    RightsHolder = "RightsHolder"
    Sponsor = "Sponsor"
    Supervisor = "Supervisor"
    WorkPackageLeader = "WorkPackageLeader"
    Other = "Other"


class Date(RootModel):
    root: Union[Any, Any, Any, Any, Any, Any, Any, Any]


class DateType(str, Enum):
    Accepted = "Accepted"
    Available = "Available"
    Copyrighted = "Copyrighted"
    Collected = "Collected"
    Created = "Created"
    Issued = "Issued"
    Submitted = "Submitted"
    Updated = "Updated"
    Valid = "Valid"
    Withdrawn = "Withdrawn"
    Other = "Other"


class ResourceTypeGeneral(str, Enum):
    Audiovisual = "Audiovisual"
    Collection = "Collection"
    DataPaper = "DataPaper"
    Dataset = "Dataset"
    Event = "Event"
    Image = "Image"
    InteractiveResource = "InteractiveResource"
    Model = "Model"
    PhysicalObject = "PhysicalObject"
    Service = "Service"
    Software = "Software"
    Sound = "Sound"
    Text = "Text"
    Workflow = "Workflow"
    Other = "Other"


class RelatedIdentifierType(str, Enum):
    ARK = "ARK"
    arXiv = "arXiv"
    bibcode = "bibcode"
    DOI = "DOI"
    EAN13 = "EAN13"
    EISSN = "EISSN"
    Handle = "Handle"
    IGSN = "IGSN"
    ISBN = "ISBN"
    ISSN = "ISSN"
    ISTC = "ISTC"
    LISSN = "LISSN"
    LSID = "LSID"
    PMID = "PMID"
    PURL = "PURL"
    UPC = "UPC"
    URL = "URL"
    URN = "URN"
    w3id = "w3id"


class RelationType(str, Enum):
    IsCitedBy = "IsCitedBy"
    Cites = "Cites"
    IsSupplementTo = "IsSupplementTo"
    IsSupplementedBy = "IsSupplementedBy"
    IsContinuedBy = "IsContinuedBy"
    Continues = "Continues"
    IsDescribedBy = "IsDescribedBy"
    Describes = "Describes"
    HasMetadata = "HasMetadata"
    IsMetadataFor = "IsMetadataFor"
    HasVersion = "HasVersion"
    IsVersionOf = "IsVersionOf"
    IsNewVersionOf = "IsNewVersionOf"
    IsPreviousVersionOf = "IsPreviousVersionOf"
    IsPartOf = "IsPartOf"
    HasPart = "HasPart"
    IsReferencedBy = "IsReferencedBy"
    References = "References"
    IsDocumentedBy = "IsDocumentedBy"
    Documents = "Documents"
    IsCompiledBy = "IsCompiledBy"
    Compiles = "Compiles"
    IsVariantFormOf = "IsVariantFormOf"
    IsOriginalFormOf = "IsOriginalFormOf"
    IsIdenticalTo = "IsIdenticalTo"
    IsReviewedBy = "IsReviewedBy"
    Reviews = "Reviews"
    IsDerivedFrom = "IsDerivedFrom"
    IsSourceOf = "IsSourceOf"
    IsRequiredBy = "IsRequiredBy"
    Requires = "Requires"
    IsObsoletedBy = "IsObsoletedBy"
    Obsoletes = "Obsoletes"


class DescriptionType(str, Enum):
    Abstract = "Abstract"
    Methods = "Methods"
    SeriesInformation = "SeriesInformation"
    TableOfContents = "TableOfContents"
    TechnicalInfo = "TechnicalInfo"
    Other = "Other"


class Longitude(RootModel):
    root: confloat(ge=-180.0, le=180.0)  # type: ignore


class Latitude(RootModel):
    root: confloat(ge=-90.0, le=90.0)  # type: ignore


class FunderIdentifierType(str, Enum):
    ISNI = "ISNI"
    GRID = "GRID"
    Crossref_Funder_ID = "Crossref Funder ID"
    ROR = "ROR"
    Other = "Other"


class Types(BaseModel):
    resourceType: str
    resourceTypeGeneral: ResourceTypeGeneral


class Creator(BaseModel):
    name: str
    nameType: Optional[NameType] = None
    givenName: Optional[str] = None
    familyName: Optional[str] = None
    nameIdentifiers: Optional[NameIdentifiers] = None
    affiliation: Optional[Affiliations] = None
    lang: Optional[str] = None


class Title(BaseModel):
    title: str
    titleType: Optional[TitleType] = None
    lang: Optional[str] = None


class Contributor(BaseModel):
    contributorType: ContributorType
    name: str
    nameType: Optional[NameType] = None
    givenName: Optional[str] = None
    familyName: Optional[str] = None
    nameIdentifiers: Optional[NameIdentifiers] = None
    affiliation: Optional[Affiliations] = None
    lang: Optional[str] = None


class DateModel(BaseModel):
    date: Date
    dateType: DateType
    dateInformation: Optional[str] = None


class RelatedIdentifier(BaseModel):
    relatedIdentifier: str
    relatedIdentifierType: RelatedIdentifierType
    relationType: RelationType
    relatedMetadataScheme: Optional[str] = None
    schemeUri: Optional[AnyUrl] = None
    schemeType: Optional[str] = None
    resourceTypeGeneral: Optional[ResourceTypeGeneral] = None


class Description(BaseModel):
    description: str
    descriptionType: DescriptionType
    lang: Optional[str] = None


class GeoLocationBox(BaseModel):
    westBoundLongitude: Longitude
    eastBoundLongitude: Longitude
    southBoundLatitude: Latitude
    northBoundLatitude: Latitude


class FundingReference(BaseModel):
    funderName: str
    funderIdentifier: Optional[str] = None
    funderIdentifierType: Optional[FunderIdentifierType] = None
    awardNumber: Optional[str] = None
    awardUri: Optional[AnyUrl] = None
    awardTitle: Optional[str] = None


class GeoLocationPoint(BaseModel):
    pointLongitude: Longitude
    pointLatitude: Latitude


class GeoLocationPolygon(BaseModel):
    polygonPoints: List[GeoLocationPoint] = Field(..., min_length=4)
    inPolygonPoint: Optional[GeoLocationPoint] = None


class GeoLocation(BaseModel):
    geoLocationPlace: Optional[str] = None
    geoLocationPoint: Optional[GeoLocationPoint] = None
    geoLocationBox: Optional[GeoLocationBox] = None
    geoLocationPolygons: Annotated[
        Optional[List[GeoLocationPolygon]], require_unique_items
    ] = None


class DataciteSchema(BaseModel):

    model_config = ConfigDict(extra="forbid")

    # tweaked identifiers, no longer requires at least one. (only change from generated code)
    types: Types
    identifiers: Annotated[
        List[Identifier],
        Field(..., min_length=1),
        require_unique_items,
    ]
    creators: Annotated[List[Creator], Field(..., min_length=1), require_unique_items]
    titles: Annotated[List[Title], Field(..., min_length=1), require_unique_items]
    publisher: str
    publicationYear: str
    subjects: Annotated[Optional[List[Subject]], require_unique_items] = None
    contributors: Annotated[Optional[List[Contributor]], require_unique_items] = None
    dates: Annotated[Optional[List[DateModel]], require_unique_items] = None
    language: Optional[str] = None
    alternateIdentifiers: Annotated[
        Optional[List[AlternateIdentifier]], require_unique_items
    ] = None
    relatedIdentifiers: Annotated[
        Optional[List[RelatedIdentifier]], require_unique_items
    ] = None
    sizes: Annotated[Optional[List[str]], require_unique_items] = None
    formats: Annotated[Optional[List[str]], require_unique_items] = None
    version: Optional[str] = None
    rightsList: Annotated[Optional[List[RightsListItem]], require_unique_items] = None
    descriptions: Annotated[Optional[List[Description]], require_unique_items] = None
    geoLocations: Annotated[Optional[List[GeoLocation]], require_unique_items] = None
    fundingReferences: Annotated[
        Optional[List[FundingReference]], require_unique_items
    ] = None
    schemaVersion: str = "http://datacite.org/schema/kernel-4"
    container: Optional[Container] = None

    @field_validator("schemaVersion")
    @classmethod
    def const(cls, v, info):
        return const_item_validator(cls, v, info)
